#ifndef ___AUDIO_H_
#define ___AUDIO_H_

#define CNV_AUDIO(b) ((b) >= 0 ? 127 - (b) : (b))
#define SAMP_RATE 8000
#define AMAX 127.0
typedef signed char audio_word;

int audio_gen_wave(audio_word* a, /* wave_data */
		   int n,	/* number of wave_data */
		   double f,	/* frequency (Hz) */
		   double vol,	/* volume [0.0, 1.0]*/
		   unsigned short m, /* M: cycle */
		   char s);	     /* S: envelope pattern */

void audio_fwrite(audio_word* a, int n, FILE* fp);
FILE* open_audio(void);
void close_audio(FILE* fp);
void set_timbre(int y);

#include "audio_cnv.h"

#endif /* ___AUDIO_H_ */

/*
 * envelope pattern:
 *
 * 0, 1, 2, 3, 9:
 * \
 *  \
 *   \_________________
 *
 *
 * 4, 5, 6, 7, 15:
 *
 *   /|
 *  / |
 * /  |________________
 *
 * 8:
 * \  |\  |\  |\  |\  
 *  \ | \ | \ | \ | \ 
 *   \|  \|  \|  \|  \
 *
 *
 * 10:
 * \    /\    /\    /
 *  \  /  \  /  \  / 
 *   \/    \/    \/  
 *
 * 11: ________________
 * \  |
 *  \ |
 *   \|
 *
 * 12:
 *   /|  /|  /|  /|  /|
 *  / | / | / | / | / |
 * /  |/  |/  |/  |/  |
 *
 * 13: __________________
 *    /
 *   /
 *  /
 *
 *
 * 14:
 *   /\    /\    /\    /\   
 *  /  \  /  \  /  \  /  \ 
 * /    \/    \/    \/    \
 *
 *
 * -1:
 * ________________________
 *
 *
 */
