#ifndef ___MMLP_H_
#define ___MMLP_H_

#define MAXLEN 256
#define CHANNEL_VMAX 0.6
#define INIT_VOL (CHANNEL_VMAX * 8.0 / 15.0)

#if !defined(INLINE)
#if defined(__GNUC__)
#define INLINE inline
#elif defined(sgi) || defined(__osf__)
#define INLINE __inline
#else
#define INLINE
#endif
#endif

enum token_types
{
    PLAY_SCALE,			/* [A-G][+#-]? */
    PLAY_SCALEN,		/* N[0-9]+ */
    OP,				/* +,#,-,.,& */
    NUMBER,			/* [0-9]+ */
    COMMAND,			/* V,L,Q,O,T,R,@,@V,M,S,<,>,{,} */
    START_LOOP,			/* |:[0-9]* */
    END_LOOP,			/* :| */
    EOPart,			/* End Of Part (,) */
    EOPhase			/* End Of Phase */
};

struct _channel_status
{
    int t;			/* T */
    double l;			/* L [1, 64] */
    unsigned char q;		/* Q [1, 8] */
    unsigned char o;		/* O [1, 9] */
    double v;			/* V[0, 15] , @V[0, 127] => [0, CHANNEL_VMAX] */
    int neiro;			/* y */
    unsigned short m;		/* M */
    unsigned char s;		/* S */
#ifdef MIDI_CFG
    int tone;			/* @ */
#endif /* MIDI_CFG */
};

extern struct _channel_status* channel_status;
extern int token_type;
extern int token_val;
extern char* mml_text;
extern lineno;
extern int trace_mode;
extern int is_beginning_of_line;
extern int current_channel;
extern double volume_ratio;
extern int input_from_stdin;
extern char* surround_parent_name;
extern int port_offset;
extern int mono_sound;
extern int mono_sound_size;
extern int check_parse_only;
#ifdef AUDRIV
extern int audriv_audio_flag;
#endif /* AUDRIV */


double NtoHz(unsigned int n);
void set_base_Hz(double f);

int gettoken(void);

void illegal_command(void);
void* xmalloc(int nbyte);

char* get_env(const char* var);
void clear_play_buffer(void);
void start_position_play(void);
void make_play_wave(int channel, double t, double f, int tai);
void make_rest_wave(double t);
void play(FILE* fp);
void begin_loop(int n);
void end_loop(void);
void add_mmltext(char* text);
char* get_next_mmltext(void);
void print_all_text_buff(void);
void ext_command(const char* cmd);
void quit(int status);

/* surround */
void exec_remote_clild(char** argv, int argc, int start_file_list);
void sync_play_start(char* parent_host);
void sync_play(void);
void close_parent_fd(void);

/* network.c */
int init_socket(int offset, char* myname);
void wait_client(int sfd, int* fd, int n);
int connect_server(char *hostname, int offset);

#endif /* ___MMLP_H_ */
